diff -uNr mythtv-0.21/libs/libmythdvdnav/searching.c mythtv/libs/libmythdvdnav/searching.c
--- mythtv-0.21/libs/libmythdvdnav/searching.c	2008-02-19 14:38:46.000000000 +0100
+++ mythtv/libs/libmythdvdnav/searching.c	2008-07-14 00:54:26.000000000 +0200
@@ -478,15 +478,11 @@
   if (menu == DVD_MENU_Escape) menu = DVD_MENU_Root;
 
   if (vm_jump_menu(try_vm, menu) && !try_vm->stopped) {
-    vm_get_next_cell(try_vm);
-    if (!try_vm->pgcN_invalid)
-    {
-      vm_free_copy(try_vm);
-      pthread_mutex_unlock(&this->vm_lock);
-      return DVDNAV_STATUS_OK;
-    }
+    vm_free_copy(try_vm);
+    pthread_mutex_unlock(&this->vm_lock);
+    return DVDNAV_STATUS_OK;
   }
-  
+
   vm_free_copy(try_vm);
   printerr("No such menu or menu not reachable.");
   pthread_mutex_unlock(&this->vm_lock);
@@ -495,7 +491,7 @@
 
 dvdnav_status_t dvdnav_menu_call(dvdnav_t *this, DVDMenuID_t menu) {
   vm_t *try_vm;
-  
+
   if(!this) {
     printerr("Passed a NULL pointer.");
     return DVDNAV_STATUS_ERR;
@@ -660,7 +656,7 @@
     return DVDNAV_STATUS_ERR;
   }
 
-  uint32_t cur_vobu, new_vobu, start, offset;
+  uint32_t cur_vobu, new_vobu = 0, start, offset;
   uint32_t first_cell_nr, last_cell_nr, cell_nr;
   cell_playback_t *cell;
   int i, length, scan_admap;
@@ -690,7 +686,7 @@
   {
     dsi = dvdnav_get_current_nav_dsi(this);
     if (length > 0) {
-      for (i = 1; i <= 19; i++) {
+      for (i = 0; i < 19; i++) {
         if (stime[i]/2.0 <= length/2.0) {
           offset = dsi->vobu_sri.fwda[i];
           if (offset >> 31) {
@@ -708,16 +704,14 @@
         }
       }
     } else {
-      for (i = 1; i <= 19; i++) {
+      for (i = 0; i < 19; i++) {
         if (stime[18 - i]/2.0 >= abs(length)/2.0)
         {
           offset = dsi->vobu_sri.bwda[i];
           if (offset >> 31) {
             new_vobu = cur_vobu - (offset & 0xffff);
           } else {
-            if (cell_nr == first_cell_nr) {
-              new_vobu = 0;
-            } else {
+            if (cell_nr != first_cell_nr) {
               cell_nr--;
               offset = state->pgc->cell_playback[cell_nr].last_sector;
               scan_admap = 1;
diff -uNr mythtv-0.21/libs/libmythfreemheg/libmythfreemheg.pro mythtv/libs/libmythfreemheg/libmythfreemheg.pro
--- mythtv-0.21/libs/libmythfreemheg/libmythfreemheg.pro	2007-12-12 03:53:59.000000000 +0100
+++ mythtv/libs/libmythfreemheg/libmythfreemheg.pro	2008-06-04 06:05:51.000000000 +0200
@@ -24,4 +24,4 @@
 
 LIBS += $$EXTRA_LIBS
 
-mingw:  target.path = $${PREFIX}/bin
+include ( ../libs-targetfix.pro )
diff -uNr mythtv-0.21/libs/libmythfreemheg/Programs.cpp mythtv/libs/libmythfreemheg/Programs.cpp
--- mythtv-0.21/libs/libmythfreemheg/Programs.cpp	2007-03-29 21:44:23.000000000 +0200
+++ mythtv/libs/libmythfreemheg/Programs.cpp	2008-06-11 13:46:52.000000000 +0200
@@ -30,7 +30,11 @@
 #include "freemheg.h"
 
 #include <sys/timeb.h>
+#ifdef __FreeBSD__ 
+#include <sys/time.h> 
+#else
 #include <time.h>
+#endif
 
 #include "../../config.h"
 
diff -uNr mythtv-0.21/libs/libmythfreesurround/libmythfreesurround.pro mythtv/libs/libmythfreesurround/libmythfreesurround.pro
--- mythtv-0.21/libs/libmythfreesurround/libmythfreesurround.pro	2008-02-14 00:47:17.000000000 +0100
+++ mythtv/libs/libmythfreesurround/libmythfreesurround.pro	2008-06-04 06:05:51.000000000 +0200
@@ -28,3 +28,5 @@
     LIBS += -L../libavcodec -lavcodec
     INCLUDEPATH += ../libavutil
 }
+
+include ( ../libs-targetfix.pro )
diff -uNr mythtv-0.21/libs/libmythlivemedia/libmythlivemedia.pro mythtv/libs/libmythlivemedia/libmythlivemedia.pro
--- mythtv-0.21/libs/libmythlivemedia/libmythlivemedia.pro	2007-09-26 22:02:25.000000000 +0200
+++ mythtv/libs/libmythlivemedia/libmythlivemedia.pro	2008-06-04 06:05:51.000000000 +0200
@@ -304,3 +304,5 @@
     SOURCES += liveMedia/WAVAudioFileServerMediaSubsession.cpp
     SOURCES += liveMedia/WAVAudioFileSource.cpp
 }
+
+include ( ../libs-targetfix.pro )
diff -uNr mythtv-0.21/libs/libmythlivemedia/liveMedia/RTSPClient.cpp mythtv/libs/libmythlivemedia/liveMedia/RTSPClient.cpp
--- mythtv-0.21/libs/libmythlivemedia/liveMedia/RTSPClient.cpp	2008-02-12 22:33:20.000000000 +0100
+++ mythtv/libs/libmythlivemedia/liveMedia/RTSPClient.cpp	2008-03-29 20:01:18.000000000 +0100
@@ -2124,11 +2124,11 @@
   Boolean haveSeenNonCRLF = False;
   int bytesRead = 1; // because we've already read the first byte
   while (bytesRead < (int)responseBufferSize) {
-    unsigned bytesReadNow
+    int bytesReadNow
       = readSocket(envir(), fInputSocketNum,
 		   (unsigned char*)(responseBuffer+bytesRead),
 		   1, fromAddress);
-    if (bytesReadNow == 0) {
+    if (bytesReadNow <= 0) {
       envir().setResultMsg("RTSP response was truncated");
       break;
     }
diff -uNr mythtv-0.21/libs/libmythlivemedia/liveMedia/RTSPCommon.cpp mythtv/libs/libmythlivemedia/liveMedia/RTSPCommon.cpp
--- mythtv-0.21/libs/libmythlivemedia/liveMedia/RTSPCommon.cpp	2006-06-21 23:20:20.000000000 +0200
+++ mythtv/libs/libmythlivemedia/liveMedia/RTSPCommon.cpp	2008-03-29 20:01:18.000000000 +0100
@@ -50,7 +50,7 @@
   // Skip over the prefix of any "rtsp://" or "rtsp:/" URL that follows:
   unsigned j = i+1;
   while (j < reqStrSize && (reqStr[j] == ' ' || reqStr[j] == '\t')) ++j; // skip over any additional white space
-  for (j = i+1; j < reqStrSize-8; ++j) {
+  for (j = i+1; (int)j < (int)(reqStrSize-8); ++j) {
     if ((reqStr[j] == 'r' || reqStr[j] == 'R')
 	&& (reqStr[j+1] == 't' || reqStr[j+1] == 'T')
 	&& (reqStr[j+2] == 's' || reqStr[j+2] == 'S')
@@ -72,7 +72,7 @@
 
   // Look for the URL suffix (before the following "RTSP/"):
   parseSucceeded = False;
-  for (unsigned k = i+1; k < reqStrSize-5; ++k) {
+  for (unsigned k = i+1; (int)k < (int)(reqStrSize-5); ++k) {
     if (reqStr[k] == 'R' && reqStr[k+1] == 'T' &&
 	reqStr[k+2] == 'S' && reqStr[k+3] == 'P' && reqStr[k+4] == '/') {
       while (--k >= i && reqStr[k] == ' ') {} // go back over all spaces before "RTSP/"
@@ -107,7 +107,7 @@
   // Look for "CSeq:", skip whitespace,
   // then read everything up to the next \r or \n as 'CSeq':
   parseSucceeded = False;
-  for (j = i; j < reqStrSize-5; ++j) {
+  for (j = i; (int)j < (int)(reqStrSize-5); ++j) {
     if (reqStr[j] == 'C' && reqStr[j+1] == 'S' && reqStr[j+2] == 'e' &&
 	reqStr[j+3] == 'q' && reqStr[j+4] == ':') {
       j += 5;
diff -uNr mythtv-0.21/libs/libmythmpeg2/libmythmpeg2.pro mythtv/libs/libmythmpeg2/libmythmpeg2.pro
--- mythtv-0.21/libs/libmythmpeg2/libmythmpeg2.pro	2007-11-05 22:12:23.000000000 +0100
+++ mythtv/libs/libmythmpeg2/libmythmpeg2.pro	2008-06-04 06:05:51.000000000 +0200
@@ -39,3 +39,5 @@
     HEADERS += alpha_asm.h
     SOURCES += motion_comp_alpha.c idct_alpha.c
 }
+
+include ( ../libs-targetfix.pro )
diff -uNr mythtv-0.21/libs/libmythsamplerate/libmythsamplerate.pro mythtv/libs/libmythsamplerate/libmythsamplerate.pro
--- mythtv-0.21/libs/libmythsamplerate/libmythsamplerate.pro	2007-09-26 22:02:25.000000000 +0200
+++ mythtv/libs/libmythsamplerate/libmythsamplerate.pro	2008-06-04 06:05:51.000000000 +0200
@@ -23,3 +23,5 @@
 inc.files = samplerate.h
 
 INSTALLS += inc
+
+include ( ../libs-targetfix.pro )
diff -uNr mythtv-0.21/libs/libmythsoundtouch/AAFilter.cpp mythtv/libs/libmythsoundtouch/AAFilter.cpp
--- mythtv-0.21/libs/libmythsoundtouch/AAFilter.cpp	2006-05-23 19:40:36.000000000 +0200
+++ mythtv/libs/libmythsoundtouch/AAFilter.cpp	2006-05-23 19:40:36.000000000 +0200
@@ -12,7 +12,7 @@
 ///
 ////////////////////////////////////////////////////////////////////////////////
 //
-// Last changed  : $Date: 2006-05-23 17:40:36 +0000 (Tue, 23 May 2006) $
+// Last changed  : $Date: 2006-05-23 19:40:36 +0200 (Di, 23. Mai 2006) $
 // File revision : $Revision: 9996 $
 //
 // $Id: AAFilter.cpp 9996 2006-05-23 17:40:36Z danielk $
diff -uNr mythtv-0.21/libs/libmythsoundtouch/AAFilter.h mythtv/libs/libmythsoundtouch/AAFilter.h
--- mythtv-0.21/libs/libmythsoundtouch/AAFilter.h	2004-11-13 23:29:45.000000000 +0100
+++ mythtv/libs/libmythsoundtouch/AAFilter.h	2004-11-13 23:29:45.000000000 +0100
@@ -13,7 +13,7 @@
 ///
 ////////////////////////////////////////////////////////////////////////////////
 //
-// Last changed  : $Date: 2004-11-13 22:29:45 +0000 (Sat, 13 Nov 2004) $
+// Last changed  : $Date: 2004-11-13 23:29:45 +0100 (Sa, 13. Nov 2004) $
 // File revision : $Revision: 4714 $
 //
 // $Id: AAFilter.h 4714 2004-11-13 22:29:45Z ijr $
diff -uNr mythtv-0.21/libs/libmythsoundtouch/BPMDetect.h mythtv/libs/libmythsoundtouch/BPMDetect.h
--- mythtv-0.21/libs/libmythsoundtouch/BPMDetect.h	2006-05-23 19:40:36.000000000 +0200
+++ mythtv/libs/libmythsoundtouch/BPMDetect.h	2006-05-23 19:40:36.000000000 +0200
@@ -26,7 +26,7 @@
 ///
 ////////////////////////////////////////////////////////////////////////////////
 //
-// Last changed  : $Date: 2006-05-23 17:40:36 +0000 (Tue, 23 May 2006) $
+// Last changed  : $Date: 2006-05-23 19:40:36 +0200 (Di, 23. Mai 2006) $
 // File revision : $Revision: 9996 $
 //
 // $Id: BPMDetect.h 9996 2006-05-23 17:40:36Z danielk $
diff -uNr mythtv-0.21/libs/libmythsoundtouch/cpu_detect.h mythtv/libs/libmythsoundtouch/cpu_detect.h
--- mythtv-0.21/libs/libmythsoundtouch/cpu_detect.h	2006-03-16 11:00:28.000000000 +0100
+++ mythtv/libs/libmythsoundtouch/cpu_detect.h	2006-03-16 11:00:28.000000000 +0100
@@ -12,7 +12,7 @@
 ///
 ////////////////////////////////////////////////////////////////////////////////
 //
-// Last changed  : $Date: 2006-03-16 10:00:28 +0000 (Thu, 16 Mar 2006) $
+// Last changed  : $Date: 2006-03-16 11:00:28 +0100 (Do, 16. Mär 2006) $
 // File revision : $Revision: 9376 $
 //
 // $Id: cpu_detect.h 9376 2006-03-16 10:00:28Z ijr $
diff -uNr mythtv-0.21/libs/libmythsoundtouch/cpu_detect_x86_gcc.cpp mythtv/libs/libmythsoundtouch/cpu_detect_x86_gcc.cpp
--- mythtv-0.21/libs/libmythsoundtouch/cpu_detect_x86_gcc.cpp	2007-11-12 15:10:42.000000000 +0100
+++ mythtv/libs/libmythsoundtouch/cpu_detect_x86_gcc.cpp	2007-11-12 15:10:42.000000000 +0100
@@ -12,7 +12,7 @@
 ///
 ////////////////////////////////////////////////////////////////////////////////
 //
-// Last changed  : $Date: 2007-11-12 14:10:42 +0000 (Mon, 12 Nov 2007) $
+// Last changed  : $Date: 2007-11-12 15:10:42 +0100 (Mo, 12. Nov 2007) $
 // File revision : $Revision: 14852 $
 //
 // $Id: cpu_detect_x86_gcc.cpp 14852 2007-11-12 14:10:42Z janne $
diff -uNr mythtv-0.21/libs/libmythsoundtouch/FIFOSampleBuffer.cpp mythtv/libs/libmythsoundtouch/FIFOSampleBuffer.cpp
--- mythtv-0.21/libs/libmythsoundtouch/FIFOSampleBuffer.cpp	2006-05-23 19:40:36.000000000 +0200
+++ mythtv/libs/libmythsoundtouch/FIFOSampleBuffer.cpp	2006-05-23 19:40:36.000000000 +0200
@@ -15,7 +15,7 @@
 ///
 ////////////////////////////////////////////////////////////////////////////////
 //
-// Last changed  : $Date: 2006-05-23 17:40:36 +0000 (Tue, 23 May 2006) $
+// Last changed  : $Date: 2006-05-23 19:40:36 +0200 (Di, 23. Mai 2006) $
 // File revision : $Revision: 9996 $
 //
 // $Id: FIFOSampleBuffer.cpp 9996 2006-05-23 17:40:36Z danielk $
diff -uNr mythtv-0.21/libs/libmythsoundtouch/FIFOSampleBuffer.h mythtv/libs/libmythsoundtouch/FIFOSampleBuffer.h
--- mythtv-0.21/libs/libmythsoundtouch/FIFOSampleBuffer.h	2006-05-23 19:40:36.000000000 +0200
+++ mythtv/libs/libmythsoundtouch/FIFOSampleBuffer.h	2006-05-23 19:40:36.000000000 +0200
@@ -15,7 +15,7 @@
 ///
 ////////////////////////////////////////////////////////////////////////////////
 //
-// Last changed  : $Date: 2006-05-23 17:40:36 +0000 (Tue, 23 May 2006) $
+// Last changed  : $Date: 2006-05-23 19:40:36 +0200 (Di, 23. Mai 2006) $
 // File revision : $Revision: 9996 $
 //
 // $Id: FIFOSampleBuffer.h 9996 2006-05-23 17:40:36Z danielk $
diff -uNr mythtv-0.21/libs/libmythsoundtouch/FIFOSamplePipe.h mythtv/libs/libmythsoundtouch/FIFOSamplePipe.h
--- mythtv-0.21/libs/libmythsoundtouch/FIFOSamplePipe.h	2005-05-23 22:39:12.000000000 +0200
+++ mythtv/libs/libmythsoundtouch/FIFOSamplePipe.h	2005-05-23 22:39:12.000000000 +0200
@@ -17,7 +17,7 @@
 ///
 ////////////////////////////////////////////////////////////////////////////////
 //
-// Last changed  : $Date: 2005-05-23 20:39:12 +0000 (Mon, 23 May 2005) $
+// Last changed  : $Date: 2005-05-23 22:39:12 +0200 (Mo, 23. Mai 2005) $
 // File revision : $Revision: 6468 $
 //
 // $Id: FIFOSamplePipe.h 6468 2005-05-23 20:39:12Z ijr $
diff -uNr mythtv-0.21/libs/libmythsoundtouch/FIRFilter.cpp mythtv/libs/libmythsoundtouch/FIRFilter.cpp
--- mythtv-0.21/libs/libmythsoundtouch/FIRFilter.cpp	2006-04-01 08:19:12.000000000 +0200
+++ mythtv/libs/libmythsoundtouch/FIRFilter.cpp	2006-04-01 08:19:12.000000000 +0200
@@ -11,7 +11,7 @@
 ///
 ////////////////////////////////////////////////////////////////////////////////
 //
-// Last changed  : $Date: 2006-04-01 06:19:12 +0000 (Sat, 01 Apr 2006) $
+// Last changed  : $Date: 2006-04-01 08:19:12 +0200 (Sa, 01. Apr 2006) $
 // File revision : $Revision: 9588 $
 //
 // $Id: FIRFilter.cpp 9588 2006-04-01 06:19:12Z ijr $
diff -uNr mythtv-0.21/libs/libmythsoundtouch/FIRFilter.h mythtv/libs/libmythsoundtouch/FIRFilter.h
--- mythtv-0.21/libs/libmythsoundtouch/FIRFilter.h	2004-11-13 23:29:45.000000000 +0100
+++ mythtv/libs/libmythsoundtouch/FIRFilter.h	2004-11-13 23:29:45.000000000 +0100
@@ -11,7 +11,7 @@
 ///
 ////////////////////////////////////////////////////////////////////////////////
 //
-// Last changed  : $Date: 2004-11-13 22:29:45 +0000 (Sat, 13 Nov 2004) $
+// Last changed  : $Date: 2004-11-13 23:29:45 +0100 (Sa, 13. Nov 2004) $
 // File revision : $Revision: 4714 $
 //
 // $Id: FIRFilter.h 4714 2004-11-13 22:29:45Z ijr $
diff -uNr mythtv-0.21/libs/libmythsoundtouch/libmythsoundtouch.pro mythtv/libs/libmythsoundtouch/libmythsoundtouch.pro
--- mythtv-0.21/libs/libmythsoundtouch/libmythsoundtouch.pro	2007-09-26 22:02:25.000000000 +0200
+++ mythtv/libs/libmythsoundtouch/libmythsoundtouch.pro	2008-06-04 06:05:51.000000000 +0200
@@ -27,3 +27,5 @@
 SOURCES += TDStretch.cpp
 SOURCES += cpu_detect_x86_gcc.cpp
 SOURCES += mmx_gcc.cpp
+
+include ( ../libs-targetfix.pro )
diff -uNr mythtv-0.21/libs/libmythsoundtouch/mmx_gcc.cpp mythtv/libs/libmythsoundtouch/mmx_gcc.cpp
--- mythtv-0.21/libs/libmythsoundtouch/mmx_gcc.cpp	2006-05-23 21:14:24.000000000 +0200
+++ mythtv/libs/libmythsoundtouch/mmx_gcc.cpp	2006-05-23 21:14:24.000000000 +0200
@@ -15,7 +15,7 @@
 ///
 ////////////////////////////////////////////////////////////////////////////////
 //
-// Last changed  : $Date: 2006-05-23 19:14:24 +0000 (Tue, 23 May 2006) $
+// Last changed  : $Date: 2006-05-23 21:14:24 +0200 (Di, 23. Mai 2006) $
 // File revision : $Revision: 9998 $
 //
 // $Id: mmx_gcc.cpp 9998 2006-05-23 19:14:24Z danielk $
diff -uNr mythtv-0.21/libs/libmythsoundtouch/RateTransposer.cpp mythtv/libs/libmythsoundtouch/RateTransposer.cpp
--- mythtv-0.21/libs/libmythsoundtouch/RateTransposer.cpp	2006-05-23 21:14:24.000000000 +0200
+++ mythtv/libs/libmythsoundtouch/RateTransposer.cpp	2006-05-23 21:14:24.000000000 +0200
@@ -10,7 +10,7 @@
 ///
 ////////////////////////////////////////////////////////////////////////////////
 //
-// Last changed  : $Date: 2006-05-23 19:14:24 +0000 (Tue, 23 May 2006) $
+// Last changed  : $Date: 2006-05-23 21:14:24 +0200 (Di, 23. Mai 2006) $
 // File revision : $Revision: 9998 $
 //
 // $Id: RateTransposer.cpp 9998 2006-05-23 19:14:24Z danielk $
diff -uNr mythtv-0.21/libs/libmythsoundtouch/RateTransposer.h mythtv/libs/libmythsoundtouch/RateTransposer.h
--- mythtv-0.21/libs/libmythsoundtouch/RateTransposer.h	2004-11-13 23:29:45.000000000 +0100
+++ mythtv/libs/libmythsoundtouch/RateTransposer.h	2004-11-13 23:29:45.000000000 +0100
@@ -14,7 +14,7 @@
 ///
 ////////////////////////////////////////////////////////////////////////////////
 //
-// Last changed  : $Date: 2004-11-13 22:29:45 +0000 (Sat, 13 Nov 2004) $
+// Last changed  : $Date: 2004-11-13 23:29:45 +0100 (Sa, 13. Nov 2004) $
 // File revision : $Revision: 4714 $
 //
 // $Id: RateTransposer.h 4714 2004-11-13 22:29:45Z ijr $
diff -uNr mythtv-0.21/libs/libmythsoundtouch/SoundTouch.cpp mythtv/libs/libmythsoundtouch/SoundTouch.cpp
--- mythtv-0.21/libs/libmythsoundtouch/SoundTouch.cpp	2006-05-24 12:48:15.000000000 +0200
+++ mythtv/libs/libmythsoundtouch/SoundTouch.cpp	2006-05-24 12:48:15.000000000 +0200
@@ -41,7 +41,7 @@
 ///
 ////////////////////////////////////////////////////////////////////////////////
 //
-// Last changed  : $Date: 2006-05-24 10:48:15 +0000 (Wed, 24 May 2006) $
+// Last changed  : $Date: 2006-05-24 12:48:15 +0200 (Mi, 24. Mai 2006) $
 // File revision : $Revision: 10003 $
 //
 // $Id: SoundTouch.cpp 10003 2006-05-24 10:48:15Z danielk $
diff -uNr mythtv-0.21/libs/libmythsoundtouch/SoundTouch.h mythtv/libs/libmythsoundtouch/SoundTouch.h
--- mythtv-0.21/libs/libmythsoundtouch/SoundTouch.h	2006-05-23 19:40:36.000000000 +0200
+++ mythtv/libs/libmythsoundtouch/SoundTouch.h	2006-05-23 19:40:36.000000000 +0200
@@ -41,7 +41,7 @@
 ///
 ////////////////////////////////////////////////////////////////////////////////
 //
-// Last changed  : $Date: 2006-05-23 17:40:36 +0000 (Tue, 23 May 2006) $
+// Last changed  : $Date: 2006-05-23 19:40:36 +0200 (Di, 23. Mai 2006) $
 // File revision : $Revision: 9996 $
 //
 // $Id: SoundTouch.h 9996 2006-05-23 17:40:36Z danielk $
diff -uNr mythtv-0.21/libs/libmythsoundtouch/STTypes.h mythtv/libs/libmythsoundtouch/STTypes.h
--- mythtv-0.21/libs/libmythsoundtouch/STTypes.h	2006-05-24 16:56:37.000000000 +0200
+++ mythtv/libs/libmythsoundtouch/STTypes.h	2006-05-24 16:56:37.000000000 +0200
@@ -8,7 +8,7 @@
 ///
 ////////////////////////////////////////////////////////////////////////////////
 //
-// Last changed  : $Date: 2006-05-24 14:56:37 +0000 (Wed, 24 May 2006) $
+// Last changed  : $Date: 2006-05-24 16:56:37 +0200 (Mi, 24. Mai 2006) $
 // File revision : $Revision: 10005 $
 //
 // $Id: STTypes.h 10005 2006-05-24 14:56:37Z danielk $
diff -uNr mythtv-0.21/libs/libmythsoundtouch/TDStretch.cpp mythtv/libs/libmythsoundtouch/TDStretch.cpp
--- mythtv-0.21/libs/libmythsoundtouch/TDStretch.cpp	2006-05-23 21:14:24.000000000 +0200
+++ mythtv/libs/libmythsoundtouch/TDStretch.cpp	2006-05-23 21:14:24.000000000 +0200
@@ -13,7 +13,7 @@
 ///
 ////////////////////////////////////////////////////////////////////////////////
 //
-// Last changed  : $Date: 2006-05-23 19:14:24 +0000 (Tue, 23 May 2006) $
+// Last changed  : $Date: 2006-05-23 21:14:24 +0200 (Di, 23. Mai 2006) $
 // File revision : $Revision: 9998 $
 //
 // $Id: TDStretch.cpp 9998 2006-05-23 19:14:24Z danielk $
diff -uNr mythtv-0.21/libs/libmythsoundtouch/TDStretch.h mythtv/libs/libmythsoundtouch/TDStretch.h
--- mythtv-0.21/libs/libmythsoundtouch/TDStretch.h	2006-05-23 21:14:24.000000000 +0200
+++ mythtv/libs/libmythsoundtouch/TDStretch.h	2006-05-23 21:14:24.000000000 +0200
@@ -13,7 +13,7 @@
 ///
 ////////////////////////////////////////////////////////////////////////////////
 //
-// Last changed  : $Date: 2006-05-23 19:14:24 +0000 (Tue, 23 May 2006) $
+// Last changed  : $Date: 2006-05-23 21:14:24 +0200 (Di, 23. Mai 2006) $
 // File revision : $Revision: 9998 $
 //
 // $Id: TDStretch.h 9998 2006-05-23 19:14:24Z danielk $
diff -uNr mythtv-0.21/libs/libmythtv/avformatdecoder.cpp mythtv/libs/libmythtv/avformatdecoder.cpp
--- mythtv-0.21/libs/libmythtv/avformatdecoder.cpp	2008-03-08 21:17:24.000000000 +0100
+++ mythtv/libs/libmythtv/avformatdecoder.cpp	2008-05-12 05:08:03.000000000 +0200
@@ -410,11 +410,10 @@
       disable_passthru(false),      max_channels(2),
       dummy_frame(NULL),
       // DVD
-      lastdvdtitle(-1), lastcellstart(0),
+      lastdvdtitle(-1),
       decodeStillFrame(false),
       dvd_xvmc_enabled(false), dvd_video_codec_changed(false),
-      dvdTitleChanged(false), mpeg_seq_end_seen(false),
-      lastDVDStillFrame(NULL)
+      dvdTitleChanged(false), mpeg_seq_end_seen(false)
 {
     bzero(&params, sizeof(AVFormatParameters));
     bzero(audioSamples, AVCODEC_MAX_AUDIO_FRAME_SIZE * sizeof(short int));
@@ -446,9 +445,6 @@
         delete pkt;
     }
 
-    if (lastDVDStillFrame)
-        av_free_packet(lastDVDStillFrame);
-
     CloseContext();
     delete ccd608;
     delete ccd708;
@@ -1444,6 +1440,13 @@
     map<int,uint> lang_sub_cnt;
     map<int,uint> lang_aud_cnt;
 
+    if (ringBuffer->isDVD() &&
+        ringBuffer->DVD()->AudioStreamsChanged())
+    {
+        ringBuffer->DVD()->AudioStreamsChanged(false);
+        RemoveAudioStreams();
+    }
+
     for (uint i = 0; i < ic->nb_streams; i++)
     {
         AVCodecContext *enc = ic->streams[i]->codec;
@@ -1511,7 +1514,7 @@
                     // HACK -- end
 
                     bool force_xv = false;
-                    if (ringBuffer->isDVD())
+                    if (ringBuffer && ringBuffer->isDVD())
                     {
                         if (dec.left(4) == "xvmc")
                             dvd_xvmc_enabled = true;
@@ -1536,7 +1539,8 @@
                     enc->codec_id = (CodecID)
                         myth2av_codecid(mcid, vcd, idct, mc);
 
-                    if (ringBuffer->isDVD() && (mcid == video_codec_id) &&
+                    if (ringBuffer && ringBuffer->isDVD() && 
+                        (mcid == video_codec_id) &&
                         dvd_video_codec_changed)
                     {
                         dvd_video_codec_changed = false;
@@ -1617,9 +1621,9 @@
 
                 InitVideoCodec(ic->streams[i], enc,
                                selectedVideoIndex == (int) i);
-
+                
                 ScanATSCCaptionStreams(i);
-
+                
                 VERBOSE(VB_PLAYBACK, LOC + 
                         QString("Using %1 for video decoding")
                         .arg(GetCodecDecoderName()));
@@ -1798,7 +1802,7 @@
             ringBuffer->UpdateRawBitrate(bitrate);
     }
 
-    if (ringBuffer->isDVD())
+    if (ringBuffer && ringBuffer->isDVD())
     {
         if (tracks[kTrackTypeAudio].size() > 1)
         {
@@ -1859,6 +1863,8 @@
     {
         GetNVP()->SetAudioParams(-1, -1, -1, false /* AC3/DTS pass-through */);
         GetNVP()->ReinitAudio();
+        if (ringBuffer && ringBuffer->isDVD()) 
+            audioIn = AudioInfo();
     }
 
     // if we don't have a video stream we still need to make sure some
@@ -1980,6 +1986,9 @@
  */
 void AvFormatDecoder::RemoveAudioStreams()
 {
+    if (!GetNVP() || !GetNVP()->HasAudioIn())
+        return;
+ 
     QMutexLocker locker(&avcodeclock);
     for (uint i = 0; i < ic->nb_streams;)
     {
@@ -3014,14 +3023,15 @@
             int dvdtitle  = 0;
             int dvdpart = 0;
             ringBuffer->DVD()->GetPartAndTitle(dvdpart, dvdtitle);
-            uint cellstart = ringBuffer->DVD()->GetCellStart();
+            bool cellChanged = ringBuffer->DVD()->CellChanged();
+            bool inDVDStill = ringBuffer->DVD()->InStillFrame();
+            bool inDVDMenu  = ringBuffer->DVD()->IsInMenu();
             selectedVideoIndex = 0;
             if (dvdTitleChanged)
             {
                 if ((storedPackets.count() > 10 && !decodeStillFrame) ||
                     decodeStillFrame)
                 {
-                    RemoveAudioStreams();
                     storevideoframes = false;
                     dvdTitleChanged = false;
                     ScanStreams(true);
@@ -3032,45 +3042,23 @@
             else
             {
                 storevideoframes = false;
-                int numVidFrames = 0;
-                if (GetNVP() && GetNVP()->getVideoOutput())
-                    numVidFrames = GetNVP()->getVideoOutput()->ValidVideoFrames();
-                bool inDVDStill = ringBuffer->DVD()->InStillFrame();
-
+                
                 if (decodeStillFrame && !inDVDStill)
-                {
                     decodeStillFrame = false;
-                }
+                
+                if (storedPackets.count() < 2 && !decodeStillFrame)
+                    storevideoframes = true;
 
-                if (numVidFrames == 0 && inDVDStill)
-                {
-                    if (lastDVDStillFrame)
-                    {
-                        VERBOSE(VB_PLAYBACK, LOC + "DVD: in still frame but "
-                                "there is no picture. Using last stored still "
-                                "frame");
-                        storedPackets.append(lastDVDStillFrame);
-                        ringBuffer->DVD()->SeekCellStart();
-                        lastDVDStillFrame = NULL;
-                        decodeStillFrame = true;
-                    }
-                    else
-                        ringBuffer->DVD()->SeekCellStart();
-                }
-                else    
-                {   
-                    if (storedPackets.count() < 2 && !decodeStillFrame)
-                        storevideoframes = true;
-                }
+                if (inDVDMenu && storedPackets.count() > 0)
+                    ringBuffer->DVD()->SetRunSeekCellStart(false);
+                else if (inDVDStill)
+                    ringBuffer->DVD()->RunSeekCellStart();
             }          
             if (GetNVP()->AtNormalSpeed() &&
-                ((lastcellstart != cellstart) || (lastdvdtitle != dvdtitle)))
+                ((cellChanged) || (lastdvdtitle != dvdtitle)))
             {
                 if (dvdtitle != lastdvdtitle)
                 {
-                    posmapStarted = false;
-                    m_positionMap.clear();
-                    SyncPositionMap();
                     VERBOSE(VB_PLAYBACK, LOC + "DVD Title Changed");
                     lastdvdtitle = dvdtitle;
                     if (lastdvdtitle != -1 )
@@ -3083,11 +3071,18 @@
                             GetNVP()->getVideoOutput()->SetPrebuffering(true);
                     }
                 }
+                
+                if (ringBuffer->DVD()->PGCLengthChanged())
+                {
+                    posmapStarted = false;
+                    m_positionMap.clear();
+                    SyncPositionMap();
+                }
+
                 UpdateDVDFramesPlayed();
                 VERBOSE(VB_PLAYBACK, QString(LOC + "DVD Cell Changed. "
                                              "Update framesPlayed: %1 ")
                                              .arg(framesPlayed));
-                lastcellstart = cellstart;
             }
         }
 
@@ -3221,7 +3216,6 @@
                     av_free_packet(pkt);
                     CloseCodecs();
                     ScanStreams(false);
-                    QMutexLocker locker(&avcodeclock);
                     allowedquit = true;
                     dvd_video_codec_changed = false;
                     continue;
@@ -3749,9 +3743,6 @@
 
                     picframe->frameNumber = framesPlayed;
                     GetNVP()->ReleaseNextVideoFrame(picframe, temppts);
-                    /* HACK remove from root of still frame display issue is fixed */
-                    if (decodeStillFrame)
-                        GetNVP()->ReleaseNextVideoFrame(picframe, temppts);
                     if (d->HasMPEG2Dec() && mpa_pic.data[3])
                         context->release_buffer(context, &mpa_pic);
 
@@ -3759,15 +3750,8 @@
                     gotvideo = 1;
                     framesPlayed++;
 
-                    if (ringBuffer->InDVDMenuOrStillFrame() && decodeStillFrame)
-                    {
-                        if (lastDVDStillFrame)
-                            av_free_packet(lastDVDStillFrame);
-                        av_dup_packet(pkt);
-                        lastDVDStillFrame = pkt;
-                        pkt = NULL;
+                    if (decodeStillFrame)
                         decodeStillFrame = false;
-                    }
 
                     lastvpts = temppts;
                     break;
@@ -3780,7 +3764,7 @@
 
                     if (ringBuffer->isDVD())
                     {
-                        if (ringBuffer->DVD()->IsInMenu())
+                        if (ringBuffer->DVD()->NumMenuButtons() > 0)
                         {
                             ringBuffer->DVD()->GetMenuSPUPkt(ptr, len,
                                                              curstream->id);
diff -uNr mythtv-0.21/libs/libmythtv/avformatdecoder.h mythtv/libs/libmythtv/avformatdecoder.h
--- mythtv-0.21/libs/libmythtv/avformatdecoder.h	2008-03-04 03:34:04.000000000 +0100
+++ mythtv/libs/libmythtv/avformatdecoder.h	2008-05-12 05:08:03.000000000 +0200
@@ -272,14 +272,11 @@
 
     // DVD
     int  lastdvdtitle;
-    uint lastcellstart;
     bool decodeStillFrame;
     bool dvd_xvmc_enabled;
     bool dvd_video_codec_changed;
     bool dvdTitleChanged;
     bool mpeg_seq_end_seen;
-    /// \brief contains last dvd still frame decoded
-    AVPacket *lastDVDStillFrame;
 };
 
 #endif
diff -uNr mythtv-0.21/libs/libmythtv/channelutil.cpp mythtv/libs/libmythtv/channelutil.cpp
--- mythtv-0.21/libs/libmythtv/channelutil.cpp	2008-02-06 23:50:10.000000000 +0100
+++ mythtv/libs/libmythtv/channelutil.cpp	2008-05-26 13:26:07.000000000 +0200
@@ -1413,6 +1413,38 @@
                            dvb_transportid, dvb_networkid, dtv_si_std);
 }
 
+bool ChannelUtil::GetChannelSettings(int chanid, bool &useonairguide,
+                                    bool &hidden)
+{
+    useonairguide = true;
+    hidden        = false;
+
+    MSqlQuery query(MSqlQuery::InitCon());
+    query.prepare(
+        "SELECT useonairguide, visible "
+        "FROM channel "
+        "WHERE chanid = :CHANID");
+    query.bindValue(":CHANID",  chanid);
+
+    if (!query.exec() || !query.isActive())
+    {
+        MythContext::DBError("GetChannelSettings", query);
+        return false;
+    }
+    else if (!query.next())
+    {
+        VERBOSE(VB_IMPORTANT, QString(
+                    "GetChannelSettings() failed because it could not "
+                    "find channel id '%1'.").arg(chanid));
+        return false;
+    }
+
+    useonairguide = (query.value(0).toInt() > 0);
+    hidden        = (query.value(1).toInt() == 0);
+
+    return true;
+}
+
 DBChanList ChannelUtil::GetChannels(uint sourceid, bool vis_only, QString grp)
 {
     DBChanList list;
diff -uNr mythtv-0.21/libs/libmythtv/channelutil.h mythtv/libs/libmythtv/channelutil.h
--- mythtv-0.21/libs/libmythtv/channelutil.h	2008-01-14 16:22:34.000000000 +0100
+++ mythtv/libs/libmythtv/channelutil.h	2008-05-26 13:26:07.000000000 +0200
@@ -176,6 +176,8 @@
         uint    &atsc_major,      uint          &atsc_minor,
         uint    &dvb_transportid, uint          &dvb_networkid,
         uint    &mplexid,         bool          &commfree);
+    static bool    GetChannelSettings(int chanid, bool &useonairguide,
+                                    bool &hidden);
     static uint    GetSourceID(uint cardid, const QString &inputname);
     static int     GetProgramNumber(uint sourceid, const QString &channum)
         { return GetChannelValueInt("serviceid", sourceid, channum); }
diff -uNr mythtv-0.21/libs/libmythtv/dbcheck.cpp mythtv/libs/libmythtv/dbcheck.cpp
--- mythtv-0.21/libs/libmythtv/dbcheck.cpp	2008-03-08 00:14:05.000000000 +0100
+++ mythtv/libs/libmythtv/dbcheck.cpp	2008-03-12 04:43:54.000000000 +0100
@@ -2858,9 +2858,11 @@
 "    UNIQUE KEY grouphostdir (groupname, hostname, dirname)"
 "    );",
 "INSERT storagegroup (groupname, hostname, dirname) "
-"    SELECT 'Default', hostname, data "
+"    SELECT DISTINCT 'Default', hostname, data "
 "    FROM settings "
-"    WHERE value = 'RecordFilePrefix';",
+"    WHERE value = 'RecordFilePrefix' "
+"        AND hostname IS NOT NULL "
+"        AND hostname <> '';",
 "ALTER TABLE recorded ADD storagegroup VARCHAR(32) NOT NULL DEFAULT 'Default';",
 "ALTER TABLE record   ADD storagegroup VARCHAR(32) NOT NULL DEFAULT 'Default';",
 "ALTER TABLE inuseprograms ADD rechost VARCHAR(64) NOT NULL;",
